do

	local oldModBlueprints = ModBlueprints
	function ModBlueprints(all_bps)
		oldModBlueprints(all_bps)

		local	r, v	=	2.0, 3.0	--	range, and velocity multipliers.
		local	e, bias	=	2.0, 1.5	--	RoF exponent, and artificial average adjustment.
		--	current values allow ACUs to 1-shot T1 Eng.

		for	id, bp in all_bps.Unit do

			if bp.Economy and bp.Economy.MaxBuildDistance then
				bp.Economy.MaxBuildDistance	=	bp.Economy.MaxBuildDistance	* r
			end
		
			if bp.Enhancements then
				
				for ik, enh in bp.Enhancements do

					if enh.NewMaxRadius then
						enh.NewMaxRadius = enh.NewMaxRadius * r
					end

				end
				
			end
		
			if bp.Intel then
				bp.Intel.VisionRadius	= 	math.floor((bp.Intel.VisionRadius or 0) * r)
				bp.Intel.UnderWaterVisionRadius = math.floor((bp.Intel.UnderWaterVisionRadius or 0) * r)
				bp.Intel.RadarRadius	= 	math.floor((bp.Intel.RadarRadius or 0) * r)
				bp.Intel.SonarRadius	= 	math.floor((bp.Intel.SonarRadius or 0) * r)
				bp.Intel.OmniRadius		= 	math.floor((bp.Intel.OmniRadius or 0) * r)
			end

			if bp.Weapon then

				for ik, wep in bp.Weapon do

					if wep.MuzzleVelocity then
					
						wep.MuzzleVelocity = wep.MuzzleVelocity * math.sqrt(r)
											
						if wep.BallisticArc == 'RULEUBA_None' then
							wep.MuzzleVelocity = wep.MuzzleVelocity * v
						else
							if not (wep.WeaponCategory == 'Artillery') then
								wep.MuzzleVelocity = wep.MuzzleVelocity * v
--							else
--								wep.MuzzleVelocity = wep.MuzzleVelocity * math.sqrt(v)
							end
							
							wep.ProjectileLifeTime = nil --	1.5 * wep.MuzzleVelocity / 4.9	--	sqrt(2) * ||velocity|| / ||a||
						end
	
					end

					if wep.MaxRadius and wep.RangeCategory != 'UWRC_Countermeasure' then
						wep.MaxRadius = math.floor(wep.MaxRadius * r)
					end
				
					if wep.ProjectileLifetime then
						wep.ProjectileLifetime = wep.ProjectileLifetime * r
					end
					
					if wep.RateOfFire then

						gain = math.pow(wep.RateOfFire / bias, e - 1)

						if gain * wep.RateOfFire < 0.05 then	--	check for stupidly low RoF; such as a Lobo's 1-shot every 100 seconds.
							gain = 0.05 / wep.RateOfFire
						end
						
						
						if gain * wep.RateOfFire > 10 then		--	check for RoFs higher than the engine's limit of 10Hz calculation rate.
							gain = 10 / wep.RateOfFire
						end
						
						wep.RateOfFire = wep.RateOfFire * gain
						wep.Damage = wep.Damage / gain
						
					end

				end	--	bp.Weapon loop

			end
		
			if bp.Wreckage and bp.Wreckage.HealthMult then
				bp.Wreckage.HealthMult	=	10
			end
			
		end	--	all_bps.Unit loop
		
		for id, em in all_bps.Emitter do
		
			if em.EmitRateCurve and em.EmitRateCurve.Keys then

				for ik, key in em.EmitRateCurve.Keys do
				
					if key.x then
						key.x = key.x * v
					end
					if key.y then
						key.y = key.y * v
					end
					if key.z then
						key.z = key.z * v
					end
				
				end

			end
		
		end	--	all_bps.Emitter loop
		
	end	--	ModBlueprints

end